`timescale 1ns / 1ps

////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:   13:26:48 11/30/2017
// Design Name:   ti_cpld_a
// Module Name:   /home/steev/Xilinx/speccy_pl_3/ti_cpld_a/ti_cpld_tb.v
// Project Name:  ti_cpld_a
// Target Device:  
// Tool versions:  
// Description: 
//
// Verilog Test Fixture created by ISE for module: ti_cpld_a
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////

module ti_cpld_tb;

	// Inputs
	reg [15:0] bus_a;
	reg [5:0] ti_in;
	reg nRD;
	reg nWR;
	reg nMREQ;
	reg nIORQ;
	reg nM1;

	// Outputs
	wire nRAMCE;
	wire nROMCE;
	wire ROMCS;
	wire [5:0] ti_out;

	// Bidirs
	wire [7:0] bus_d;

	// Outputs
	wire nRAMCE2;
	wire nROMCE2;
	wire ROMCS2;
	wire [5:0] ti_out2;

	// Bidirs
	wire [7:0] bus_d2;

	// Outputs
	wire nRAMCE3;
	wire nROMCE3;
	wire ROMCS3;
	wire [5:0] ti_out3;

	// Bidirs
	wire [7:0] bus_d3;


	// Instantiate the Unit Under Test (UUT)
	ti_cpld_a uut (
		.bus_a(bus_a), 
		.ti_in(ti_in), 
		.nRD(nRD), 
		.nWR(nWR), 
		.nMREQ(nMREQ), 
		.nIORQ(nIORQ), 
		.nM1(nM1), 
		.bus_d(bus_d), 
		.nRAMCE(nRAMCE), 
		.nROMCE(nROMCE), 
		.ROMCS(ROMCS), 
		.ti_out(ti_out)
	);

	ti_cpld_s uut2 (
		.bus_a(bus_a), 
		.ti_in(ti_in), 
		.nRD(nRD), 
		.nWR(nWR), 
		.nMREQ(nMREQ), 
		.nIORQ(nIORQ), 
		.nM1(nM1), 
		.bus_d(bus_d2), 
		.nRAMCE(nRAMCE2), 
		.nROMCE(nROMCE2), 
		.ROMCS(ROMCS2), 
		.ti_out(ti_out2)
	);

	ti_cpld_c uut3 (
		.bus_a(bus_a), 
		.ti_in(ti_in), 
		.nRD(nRD), 
		.nWR(nWR), 
		.nMREQ(nMREQ), 
		.nIORQ(nIORQ), 
		.nM1(nM1), 
		.bus_d(bus_d3), 
		.nRAMCE(nRAMCE3), 
		.nROMCE(nROMCE3), 
		.ROMCS(ROMCS3), 
		.ti_out(ti_out3)
	);


	initial begin
		// Initialize Inputs
		bus_a = 0;
		ti_in = 0;
		nRD = 1;
		nWR = 1;
		nMREQ = 1;
		nIORQ = 1;
		nM1 = 1;	
		// Wait 100 ns for global reset to finish
		//#100;
        
		// Add stimulus here
	end
	
	task mRead(input [15:0] address);
	begin
		#5		bus_a[15:0] = address[15:0];
		#5		nMREQ = 0;
				nRD = 0;
		#25 	nMREQ = 1;
				nRD = 1;
		#5;
	end
	endtask

	task mCmd (input [15:0] address);
	begin
		#5		bus_a[15:0] = address[15:0];
				nM1 = 0;
		#5 	nMREQ = 0;
				nRD = 0;
		
		#25	nMREQ = 1;
				nRD = 1;
				nM1 = 1;
		#5;
	end
	endtask

	task ioRead(input [15:0] address, input [7:0] val);
	begin
		#5		bus_a[15:0] = address[15:0];
				ti_in[5:0] = val[5:0];
		#5		nIORQ = 0;
				nRD = 0;
		#25 	nIORQ = 1;
				nRD = 1;
		#5;
	end
	endtask

	task ioWrite( input [15:0] address, input [7:0] val);
	begin
		#5		bus_a[15:0] = address[15:0];
				force bus_d[7:0] = val[7:0];
				force bus_d2[7:0] = val[7:0];
				force bus_d3[7:0] = val[7:0];
		#5		nIORQ = 0;
				nWR = 0;
		#25	nIORQ = 1;
				nWR = 1;
		#5		release bus_d[7:0];
				release bus_d2[7:0];
				release bus_d3[7:0];
		#5;
	end
	endtask

//	assign bus_d[7:0] = 8'bzzzzzzzz;	
//	assign bus_d2[7:0] = 8'bzzzzzzzz;	
//	assign bus_d3[7:0] = 8'bzzzzzzzz;	
	
	// test przełączania pamięci
	
	always begin
		mRead(16'd65535);
		mRead(16'd0);
		mRead(16'd1);
		mRead(16'd7);
		mRead(16'd8);
		mRead(16'd9);

		mCmd(16'd65535);
		mCmd(16'd0);
		mCmd(16'd1);
		mRead(16'h1fff);
		mRead(16'h2000);
		mRead(16'h2001);
		mCmd(16'h0603);
		mCmd(16'h0604);
		mCmd(16'h0605);
		mCmd(16'd7);
		mCmd(16'd8);
		mCmd(16'd9);
		mRead(16'h1fff);
		mRead(16'h2000);
		mRead(16'h2001);
		mCmd(16'h0603);
		mCmd(16'h0604);
		mCmd(16'h0605);

		ioRead(16'h00ee,8'h01);
		ioRead(16'h00ef,8'h02);
		ioRead(16'h00f0,8'h03);
		ioWrite(16'h00ee,8'h04);
		ioWrite(16'h00ef,8'h05);
		ioWrite(16'h00f0,8'h06);
		
		ioRead(16'h00ee,8'h51);
		ioRead(16'h00ef,8'h52);
		ioRead(16'h00f0,8'h53);
		ioWrite(16'h00ee,8'h54);
		ioWrite(16'h00ef,8'h55);
		ioWrite(16'h00f0,8'h56);
	end
      
endmodule

